#include "ContactFactory.h"
#include <stdlib.h>
#include <time.h>

//operator overloading
ContactFactory& operator>>(ContactFactory& cf, ContactList& cl){
   cl.add(cf.createContact());
   return cf;
}

//constructor initializing data members with random data
ContactFactory::ContactFactory(){
    categories << 1 << 2 << 3;
    firstNames << "AB" << "CD" << "FF" << "G" << "Ann" << "Leo" << "Mathe" << "Martha" << "Lata" << "Mersault" << "Gerald" << "Tonic" << "Tom" << "Anna" << "Hilda";
    lastNames << "Botha" << "Viljoen" << "Kotze" << "Mentz" << "van der Merwe" << "Naidoo" << "Liang" << "Kritzinger" << "Becker" << "Lubbe" << "Engelbrecht" << "Schoeman"<< "Horne" << "Eloff" << "Selati";
    streetAddresses << "32 Menlyn" << "1 Kelvin" << "74 - 23rd street" << "100 Lion" << "3 Protea Road" << "302 Muskejaat" << "45 Lois Street" << "100 Skilpad" << "29 Atterbury Road" << "567 Selati Street" << "34 Preller Street" << "75 Puzzle Road" <<"100 Endless Street" << "45 Leak Street" << "786 Good Hope";
    zipCodes << "00S01" << "0010" << "0100" << "1000" << "1001" << "1010" << "1100" << "1101" << "1110" << "1111" << "1002"<< "1003" << "3045" << "1005" << "0003";
    cities << "Pretoria" << "Victoria" << "East City" << "West Rand" << "Potchefstroom" << "Mogale City" << "Cape City" << "Milton" << "Port Elizabeth" << "Klerksdorp" << "Krugersdorp" << "Randburg" << "Florida" << "Randfontein" << "Ventersdorp";
    phoneNumbers << "012 4419087" << "022 4699087" << "013 4699000" << "018 4520123" << "025 1238567" <<"014 5967824" << "015 8951234" << "078 4699123" << "074 3546902" << "020 7864532" <<"032 3402789" <<"004 7878990" <<"034 8902346" <<"021 6748321" <<"022 6990001";

    srand(time(0));
}

//creates and returns a Contact, where the information is randomly selected
Contact* ContactFactory:: createContact(){
    int randCat = categories[rand()%categories.size()];
    QString randFName = firstNames[rand()%firstNames.size()];
    QString randLName = lastNames[rand()%lastNames.size()];
    QString randSAddr = streetAddresses[rand()%streetAddresses.size()];
    QString randZCode = zipCodes[rand()%zipCodes.size()];
    QString randCity = cities[rand()%cities.size()];
    QString randPNum = phoneNumbers[rand()%phoneNumbers.size()];
    return new Contact(randCat, randFName, randLName, randSAddr, randZCode, randCity, randPNum);
}
