#include "contactlistwriter.h"

ContactListWriter::ContactListWriter(){
    rootElement = doc.createElement("contactlist");
    doc.appendChild(rootElement);
}

void ContactListWriter::write(ContactList *cl){

    QList<Contact*> list = cl->findChildren<Contact*>();
     foreach (Contact* co, list){
         QDomElement contactElement = doc.createElement("contact");
         rootElement.appendChild(contactElement);

         QDomElement categoryElement = doc.createElement("category");
         QDomText categoryText = doc.createTextNode(QString::number(co->getCategory(), 10));
         contactElement.appendChild(categoryElement);
         categoryElement.appendChild(categoryText);

         QDomElement firstNameElement = doc.createElement("firstname");
         QDomText firstNameText = doc.createTextNode(co->getFirstName());
         contactElement.appendChild(firstNameElement);
         firstNameElement.appendChild(firstNameText);

         QDomElement lastNameElement = doc.createElement("lastname");
         QDomText lastNameText = doc.createTextNode(co->getLastName());
         contactElement.appendChild(lastNameElement);
         lastNameElement.appendChild(lastNameText);

         QDomElement streetAddressElement = doc.createElement("streetaddress");
         QDomText streetAddressText = doc.createTextNode(co->getStreetAddress());
         contactElement.appendChild(streetAddressElement);
         streetAddressElement.appendChild(streetAddressText);

         QDomElement zipCodeElement = doc.createElement("zipcode");
         QDomText zipCodeText = doc.createTextNode(co->getZipCode());
         contactElement.appendChild(zipCodeElement);
         zipCodeElement.appendChild(zipCodeText);

         QDomElement cityElement = doc.createElement("city");
         QDomText cityText = doc.createTextNode(co->getCity());
         contactElement.appendChild(cityElement);
         cityElement.appendChild(cityText);

         QDomElement phoneNumberElement = doc.createElement("phonenumber");
         QDomText phoneNumberText = doc.createTextNode(co->getPhoneNumber());
         contactElement.appendChild(phoneNumberElement);
         phoneNumberElement.appendChild(phoneNumberText);
    }

}

QDomDocument ContactListWriter::getDoc() const {
    return doc;
}
