#include "contactfactory.h"
#include "contactlistwriter.h"
#include "contactlistprocessor.h"

#include <QTextStream>
#include <QFile>
#include <QXmlSimpleReader>

QTextStream cout(stdout);

//creates random contacts using ContactFactory
void createRandomContacts(ContactList& cl, int n=10){
    static ContactFactory cf;
    for (int i=0; i<n; ++i) {
        cf >> cl;
    }
}

int main(int argc, char *argv[]){       
    ContactList l1;
    createRandomContacts(l1);

    cout << "Here is the list of randomly generated contacts:"<< endl;
    cout << endl;
    cout << l1.toString();

    int i = 1;

    cout << endl;
    cout<< "Here is the list of telephone numbers of contacts with id:" << i << endl;

    QStringList pl = l1.getPhoneList(i);
    foreach(QString s, pl){
        cout<< s <<endl;
    }

    cout << endl;
    cout<< "Total number of contacts is : " << l1.getSize()<<endl;
    cout<<"Number of contacts with id: " << i << " is " << pl.size()<<endl;

    i =3;

    cout << endl;
    cout<< "Here is the list of mailing addresses of contacts with id:" << i <<endl;
    pl = l1.getMailingList(i);
    foreach(QString s, pl){
        cout<< s<< endl;
    }

    cout << endl;
    cout<<"Total number of contacts is : " << l1.getSize()<<endl;
    cout<<"Number of contacts with id: " << i << " is " << pl.size()<<endl;
    cout<<endl;

    Contact* c1 = new Contact(5,"Jay", "Manale", "School of Computing, UNISA", "0003", "Pretoria","012 345 678");
    cout<< "Adding a new contact..." << endl;
    l1.add(c1);

    cout<< "Updated size of the contact list : " << l1.getSize()<< endl;
    cout<< "Updated contact list : " << endl;
    cout<< l1.toString() << endl;

    cout<< "Removing a contact... " << endl;
    l1.remove(c1);
    cout<< "Updated size of the contact list : " << l1.getSize()<< endl;
    cout<< "Updated contact list : " << endl;
    cout<< l1.toString() << endl;

    QFile contactFile("contactlist.xml");
    contactFile.open(QIODevice::ReadWrite);
    QTextStream toFile(&contactFile);

    QFile formattedContactFile("contactlistformat.txt");
    formattedContactFile.open(QIODevice::ReadWrite);
    QTextStream toFileFormat(&formattedContactFile);

    ContactListWriter clw;
    clw.write(&l1);
    QDomDocument tempDoc = clw.getDoc();
    toFile << tempDoc.toString();
    contactFile.close();

    cout<< "Saving contacts in XML format.." << endl;

    ContactListProcessor clp;
    QXmlSimpleReader reader;
    reader.setContentHandler(&clp);
    QXmlInputSource source(&contactFile);
    reader.parse(source);
    toFileFormat << clp.toString();
    formattedContactFile.close();

    cout<< "Saving contacts in address format.." << endl << endl;

    return 0;
}
