#include "ContactList.h"
#include <QList>
#include <QPair>

QMap<int, ContactList*> ContactList::initInstances() {
    QMap<int, ContactList*>map;
    map.insert(1, new ContactList());
    map.insert(2, new ContactList());
    map.insert(3, new ContactList());
    return map;
}

QMap<int, ContactList*> ContactList::instances = initInstances();

ContactList* ContactList::getInstance(int i){
    return instances.value(i);
}

//adds a contact
void ContactList::add(Contact* c){
    c->setParent(this);
}

//removes a contact if in the list
void ContactList::remove(Contact* c){
    QList<Contact*> list = this->findChildren<Contact*>();
        foreach (Contact* co, list){
            if((co->getFirstName() == c->getFirstName()) && (co->getLastName() == c->getLastName())){
               delete co;
            }
        }
}

//returns the size of the list
int ContactList::getSize()const{
   return this->findChildren<Contact*>().size();
}

//returns the phone list given a category
QStringList ContactList::getPhoneList()const{
    QStringList phoneList;
    QString entry;
    QList<Contact*> list = this->findChildren<Contact*>();
     foreach (Contact* co, list){
            entry = co->getFirstName()+ " " + co->getLastName() + ", " + co->getPhoneNumber();
            phoneList << entry;
    }
    return phoneList;
}

//returns the addresses given a category
QStringList ContactList::getMailingList()const{
    QStringList mailingList;
    QString entry;
    QList<Contact*> list = this->findChildren<Contact*>();
     foreach (Contact* co, list){
            entry = co->getFirstName()+ " " + co->getLastName() + ", " +co->getStreetAddress()+ ", " + co->getCity()+ ", " +co->getZipCode();
            mailingList << entry;
    }
    return mailingList;
}

//returns a string representation of the list
QString ContactList::toString()const{
    QString entry;
    QList<Contact*> list = this->findChildren<Contact*>();
     foreach (Contact* co, list){
        entry = entry + co->toString() + "\n";
    }
    return entry;
}
