#include "contactfactory.h"
#include <QTextStream>
#include <QFile>
#include <QXmlSimpleReader>

QTextStream cout(stdout);

int main(int argc, char *argv[]){

    static ContactFactory cf;

    ContactList* l1 = ContactList::getInstance(1);
    ContactList* l2 = ContactList::getInstance(2);
    ContactList* l3 = ContactList::getInstance(3);

    for (int i=0; i<10; ++i) {
      Contact *c = cf.createContact();
      if(c->getCategory()==1)
            l1->add(c);
      if(c->getCategory()==2)
            l2->add(c);
      if(c->getCategory()==3)
            l3->add(c);
    }
     cout << "Here is the list (category 1) of randomly generated contacts:"<< endl;
     cout << l1->toString();
     cout << "\n\n";
     cout << "Here is the list (category 2) of randomly generated contacts:"<< endl;
     cout << l2->toString();
     cout << "\n\n";
     cout << "Here is the list (category 3) of randomly generated contacts:"<< endl;
     cout << l3->toString();
     cout << "\n\n";

     cout<< "Here is the list (category 2)of telephone numbers of contacts " << endl;

     QStringList pl = l2->getPhoneList();
     foreach(QString s, pl){
        cout<< s <<endl;
    }

    cout << "\n\n";

    cout<< "Total number of contacts in category 3 is : " << l3->getSize()<<endl;

    cout << "\n\n";

    cout<< "Here is the list (category 2) of mailing addresses of contacts " <<endl;
    pl = l2->getMailingList();
    foreach(QString s, pl){
        cout<< s<< endl;
    }

    cout << "\n\n";
    Contact* c1 = new Contact(1,"Jay", "Manale", "School of Computing, UNISA", "0003", "Pretoria","012 345 678");
    cout<< "Adding a new contact to list (category 1)..." << endl;
    l1->add(c1);
    cout << "\n\n";

    cout<< "Updated size of the contact list (category 1) : " << l1->getSize()<< endl;
    cout<< "Updated contact list : " << endl;
    cout<< l1->toString() << endl;

    cout << "\n\n";

    cout<< "Removing a contact from the list (category 1)... " << endl;
    l1->remove(c1);
    cout << "\n";
    cout<< "Updated size of the contact list (category 1) : " << l1->getSize()<< endl;
    cout << "\n";
    cout<< "Updated contact list (category 1): " << endl;
    cout<< l1->toString() << endl;

    delete l1;
    delete l2;
    delete l3;


    return 0;
}
