#ifndef RANDOMQUOTES_H
#define RANDOMQUOTES_H

#include <QWidget>
#include <QStringList>
#include <QTimer>
#include <QLabel>
#include <QLineEdit>
#include <QTextEdit>
#include <QPushButton>

#include "quotefactory.h"

class RandomQuotes: public QWidget{
    Q_OBJECT
public:
    //constructor
    RandomQuotes();

private slots:
    //set timer
    void setTimer();
    //display quotes
    void displayQuotes();
    //cancel timer
    void cancelTimer();

private:
    //widget data members
    QLabel* timerLabel;
    QLineEdit* timerEdit;
    QTextEdit* quoteEdit;
    QPushButton* okButton;
    QPushButton* cancelButton;    
    //timer
    QTimer* timer;
    //quote factory instance
    QuoteFactory qf;
    //sets up the GUI and connects signals and slots
    void setUpGUI();

};

#endif // RANDOMQUOTES_H
