#ifndef WEBBROWSER_H
#define WEBBROWSER_H

#include <QWidget>
#include <QPushButton>
#include <QListView>
#include <QUrl>
#include <QStringListModel>

class QLineEdit;
class QToolButton;
class QWebView;


class WebBrowser : public QWidget
{
    Q_OBJECT
public:
    WebBrowser(QWidget *parent = 0);

signals:

public slots:
    void loadPage();
    void updateAddressBar(const QUrl &url);
    void highlight();    
    void listLinks();
    void addURL(const QUrl &url);

private:
    QLineEdit *addressBar;
    QToolButton *backButton;
    QToolButton *forwardButton;
    QToolButton *reloadButton;
    QPushButton *findLinksButton;
    QLineEdit *findtext;

    QListView* linkList;    
    QStringListModel model;
    QStringList links;
    QWebView *browser;

};

#endif // WEBBROWSER_H
