#ifndef MYNOTEPAD_H
#define MYNOTEPAD_H

#include <QMainWindow>
#include <QActionGroup>
#include <QTextEdit>
#include <QStack>
#include "textandstyle.h"

class MyNotepad : public QMainWindow {
    Q_OBJECT
  public:
    //constructor
    MyNotepad();
    ~MyNotepad();
  protected slots:
    //a function to handle events
    void actionEvent(QAction* act);
  protected:
    //to create a QAction for a given choice
    QAction* addChoice(QString name, QString text);
  private:
    //data members
    QTextEdit* textEdit;    
    QActionGroup* actionGroup;
    QAction* bold;
    QAction* underline;
    QAction* italics;
    QAction* save;
    QAction* undo;

    int undos;
    QStack<TextAndStyleMemento*> mementos;

    void setBold(QTextCursor& tc, QTextCharFormat format);
    void setItalics(QTextCursor& tc, QTextCharFormat format);
    void setUnderline(QTextCursor& tc, QTextCharFormat format);
    void createAndStoreMemento();
    void restore();
    void setStyle(QString st);

 };

#endif // MYNOTEPAD_H
