#include "counterviewwidget.h"
#include <QStringList>
#include <QGridLayout>

CounterViewWidget::CounterViewWidget(QString t){

    QStringList strings = QStringList() << "starting no:" << "ending no:" << "increment:" << "delay:";
    for(int i =0; i<4; i++){
        labels[i] = new QLabel(strings.at(i));
        lineEdits[i] = new QLineEdit();
    }
    button = new QPushButton("Start");

    QGridLayout *grid = new QGridLayout();
    grid->addWidget(labels[0],0,0);
    grid->addWidget(lineEdits[0],0,1);
    grid->addWidget(labels[1],1,0);
    grid->addWidget(lineEdits[1],1,1);
    grid->addWidget(labels[2],2,0);
    grid->addWidget(lineEdits[2],2,1);
    grid->addWidget(labels[3],3,0);
    grid->addWidget(lineEdits[3],3,1);
    grid->addWidget(button,4,1);

    this->setLayout(grid);
    this->setWindowTitle(t);

    connect(button, SIGNAL(clicked()), this, SLOT(readData()));
}

void CounterViewWidget::readData(){

    bool ok = true;
    QString ss = lineEdits[0]->text();
    int is = ss.toInt(&ok, 10);
    QString se = lineEdits[1]->text();
    int ie = se.toInt(&ok, 10);
    QString si = lineEdits[2]->text();
    int ii = si.toInt(&ok, 10);
    QString sd = lineEdits[3]->text();
    int id = sd.toInt(&ok, 10);

    emit valuesEntered(is,ie,ii,id, this->windowTitle());
}
