#include "udpsend.h"
#include <QUdpSocket>
#include <QPushButton>
#include <QStringList>
#include <QLabel>
#include <QLayout>
#include <QTime>
#include <QTimer>

UDPSend::UDPSend(QWidget *parent) : QWidget(parent)
{
    socket = 0;

    insults << "He had delusions of adequacy"
            << "He has all the virtues I dislike and none of the vices I admire"
            << "I feel so miserable without you; it's almost like having you here"
            << "He is a self-made man and worships his creator"
            << "He is not only dull himself; he is the cause of dullness in others"
            << "Why do you sit there looking like an envelope without any address on it"
            << "His mother should have thrown him away and kept the stork"
            << "Some cause happiness wherever they go; others, whenever they go"
            << "He has van Gogh's ear for music";

    QPushButton* start = new QPushButton("Start");
    status = new QLabel("Waiting to start...");
    QVBoxLayout* layout = new QVBoxLayout(this);
    layout->addWidget(start);
    layout->addWidget(status);

   connect(start, SIGNAL(clicked()), this, SLOT(startSending()));

   QTime now = QTime::currentTime();
   qsrand(now.msec());
}

void UDPSend::startSending()
{
    status->setText("Starting to send...");

    socket = new QUdpSocket(this);

    timer = new QTimer(this);
    timer->setInterval(qrand()%10000);
    timer->start();
    connect(timer, SIGNAL(timeout()), this, SLOT (sendMessage()));
}

void UDPSend::sendMessage()
{
    QByteArray buffer;
    QDataStream stream(&buffer, QIODevice::WriteOnly);
    stream.setVersion(QDataStream::Qt_4_0);
    QString msg = insults.at(qrand()%9);
    stream <<  msg;
    socket->writeDatagram(buffer, QHostAddress::Broadcast, 34567);
    timer->setInterval(qrand()%10000);
}
